-- name: [CS] \\#5cbbfa\\Martlet
-- description: Snowdin's former Royal Guard, reporting in.\nOr sleeping in.\nOne of the two.\n\nCharacter by Team UTY.\nDesign by Emmalume.\nVoiced by Ciozio.\n\n\\#ff7777\\This Pack requires Character Select\nto use as a Library!

-- Replace Mod Name with your Character/Pack name.
local TEXT_MOD_NAME = "Martlet"

-- Stops mod from loading if Character Select isn't on
if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

local E_MODEL_MARTLET =      smlua_model_util_get_id("martlet_geo")      -- Located in "actors"
local E_MODEL_MARTLET_STAR = smlua_model_util_get_id("martlet_star_geo") -- Located in "actors"

local TEX_MARTLET_LIFE_ICON = get_texture_info("martlet-icon") -- Located in "textures"
local TEX_MARTLET_STAR_ICON = get_texture_info("martlet-star-icon") -- Located in "textures"

-- All sound files are located in "sound" folder
local VOICETABLE_MARTLET = {
	[CHAR_SOUND_HELLO] =			 'martlet_hello.ogg',
    [CHAR_SOUND_OKEY_DOKEY] =        'martlet_okey_dokey.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] =         'martlet_lets_a_go.ogg', -- Starting level
	[CHAR_SOUND_GAME_OVER] =         'martlet_game_over.ogg',
	[CHAR_SOUND_PUNCH_YAH] =         'martlet_punch_yah.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] =         'martlet_punch_wah.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] =         'martlet_punch_hoo.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] =       {'martlet_yah.ogg', 'martlet_wah.ogg', 'martlet_hoo.ogg'}, -- First Jump Sounds
	[CHAR_SOUND_HOOHOO] =            'martlet_hoohoo.ogg', -- Second jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'martlet_yahoo.ogg', 'martlet_yahoo2.ogg', 'martlet_yahoo3.ogg', 'martlet_yahoo4.ogg', 'martlet_yahoo5.ogg', 'martlet_yahoo6.ogg', 'martlet_waha.ogg', 'martlet_waha2.ogg', 'martlet_yippee.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] =                'martlet_uh.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] =               'martlet_uh2.ogg', -- Fast ledge climb
	[CHAR_SOUND_UH2_2] =             'martlet_uh2_2.ogg', -- Landing after long jump
	[CHAR_SOUND_HAHA] =              'martlet_haha.ogg', -- Landing triple jump
	[CHAR_SOUND_HAHA_2] =            'martlet_haha.ogg', -- Plunging into water
	[CHAR_SOUND_YAHOO] =             {'martlet_yahoo.ogg', 'martlet_yahoo2.ogg', 'martlet_yahoo3.ogg', 'martlet_yahoo4.ogg', 'martlet_yahoo5.ogg', 'martlet_yahoo6.ogg'}, -- Long jump
	[CHAR_SOUND_DOH] =               'martlet_doh.ogg', -- Long jump wall bonk
	[CHAR_SOUND_OOOF] =				 'martlet_ooof.ogg', -- Landing after wall bonk
	[CHAR_SOUND_OOOF2] = 			 'martlet_ooof.ogg',
	[CHAR_SOUND_WHOA] =              'martlet_whoa.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] =              'martlet_eeuh.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] =          'martlet_waaaooow.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] =      'martlet_twirl_bounce.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] =  'martlet_ground_pound_wah.ogg', -- Ground pounding
	[CHAR_SOUND_WAH2] =  			 'martlet_ground_pound_wah.ogg', -- Throwing objects
	[CHAR_SOUND_HRMM] =              'martlet_hrmm.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] =        'martlet_here_we_go.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] =   {'martlet_so_longa_bowser.ogg', 'martlet_so_longa_bowser2.ogg', 'martlet_so_longa_bowser3.ogg', 'martlet_so_longa_bowser4.ogg',
									  'martlet_so_longa_bowser.ogg', 'martlet_so_longa_bowser2.ogg', 'martlet_so_longa_bowser3.ogg', 'martlet_so_longa_bowser4.ogg',
									  'martlet_so_longa_bowser.ogg', 'martlet_so_longa_bowser2.ogg', 'martlet_so_longa_bowser3.ogg', 'martlet_so_longa_bowser4.ogg',
									  'martlet_so_longa_bowser.ogg', 'martlet_so_longa_bowser2.ogg', 'martlet_so_longa_bowser3.ogg', 'martlet_so_longa_bowser4.ogg',
									  'martlet_so_longa_bowser.ogg', 'martlet_so_longa_bowser2.ogg', 'martlet_so_longa_bowser3.ogg', 'martlet_so_longa_bowser4.ogg',
									  'martlet_so_longa_bowser5.ogg'}, -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'martlet_attacked.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'martlet_panting.ogg', -- Low health
	--[CHAR_SOUND_PANTING_COLD] = 'martlet_sound.ogg', -- Idle animation in cold areas
	[CHAR_SOUND_ON_FIRE] = {'martlet_on_fire.ogg', 'martlet_on_fire2.ogg', 'martlet_on_fire3.ogg', 'martlet_on_fire4.ogg'}, -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'martlet_ima_tired.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'martlet_yawning.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'martlet_snoring1.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'martlet_snoring2.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'martlet_snoring3.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'martlet_coughing.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'martlet_coughing.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'martlet_coughing.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'martlet_dying.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'martlet_drowning.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'martlet_mama_mia.ogg' -- Booted out of level
}

-- All Located in "actors" folder
local CAPTABLE_MARTLET = {
    normal = smlua_model_util_get_id("martlet_normal_geo"),
    wing = smlua_model_util_get_id("martlet_wing_geo"),
    metal = smlua_model_util_get_id("martlet_metal_geo"),
	metalWing = smlua_model_util_get_id("martlet_metalwing_geo"),
}

local PALETTE_MARTLET = {
    [PANTS]  = "437ce6",
    [SHIRT]  = "c5faff",
    [GLOVES] = "5cbbfa",
    [SHOES]  = "fbc038",
    [HAIR]   = "437ce6",
    [SKIN]   = "c5faff",
    [CAP]    = "437ce6",
	[EMBLEM] = "437ce6"
}

-- All Located in "textures" folder
local HEALTH_METER_MARTLET = {
    label = {
        left = get_texture_info("martlet-meter-left"),
        right = get_texture_info("martlet-meter-right"),
    },
    pie = {
        [1] = get_texture_info("martlet-meter-pie1"),
        [2] = get_texture_info("martlet-meter-pie2"),
        [3] = get_texture_info("martlet-meter-pie3"),
        [4] = get_texture_info("martlet-meter-pie4"),
        [5] = get_texture_info("martlet-meter-pie5"),
        [6] = get_texture_info("martlet-meter-pie6"),
        [7] = get_texture_info("martlet-meter-pie7"),
        [8] = get_texture_info("martlet-meter-pie8"),
    }
}

local ANIMTABLE_MARTLET = {
	[CHAR_ANIM_WATER_STAR_DANCE] =					"martlet_water_star_dance",
	[CHAR_ANIM_RETURN_FROM_WATER_STAR_DANCE] =		"martlet_water_star_dance_return",
	[CHAR_ANIM_STAR_DANCE] = 						"martlet_star_dance",
	[CHAR_ANIM_RETURN_FROM_STAR_DANCE] = 			"martlet_star_dance_return",
	
	[CHAR_ANIM_PUT_CAP_ON] =						"martlet_put_cap_on",
	[CHAR_ANIM_TAKE_CAP_OFF_THEN_ON] =				"martlet_take_cap_off_then_on",
	[CHAR_ANIM_MISSING_CAP] =						"martlet_missing_cap",
	
	[CHAR_ANIM_FINAL_BOWSER_RAISE_HAND_SPIN] =		"martlet_final_bowser_raise_hand_spin",
	[CHAR_ANIM_FINAL_BOWSER_WING_CAP_TAKE_OFF] =	"martlet_final_bowser_wing_cap_take_off",
}

local CSloaded = false
local function on_character_select_load()
    -- Adds the custom character to the Character Select Menu
    CT_MARTLET = _G.charSelect.character_add(
        "Martlet", -- Character Name
        "Snowdin's former Royal Guard, reporting in.\nOr sleeping in.\nOne of the two.\n\nCharacter by Team UTY.\nDesign by Emmalume.\nVoiced by Ciozio.", -- Description
        "Micharus / VA: Ciozio",	-- Credits
        "5cbbfa",          			-- Menu Color
        E_MODEL_MARTLET,			-- Character Model
        CT_MARIO,           		-- Override Character
        TEX_MARTLET_LIFE_ICON, 		-- Life Icon
        1,                  		-- Camera Scale
        0                   		-- Vertical Offset
    )

    -- Adds cap models to your character
    -- (Models do not exist in template)
    _G.charSelect.character_add_caps(E_MODEL_MARTLET, CAPTABLE_MARTLET)

    -- Adds a voice to your character
    -- (Sounds do not exist in template)
    _G.charSelect.character_add_voice(E_MODEL_MARTLET, VOICETABLE_MARTLET)

    -- Adds a celebration star to your character
    -- (Models do not exist in template)
    _G.charSelect.character_add_celebration_star(E_MODEL_MARTLET, E_MODEL_MARTLET_STAR, TEX_MARTLET_STAR_ICON)

    -- Adds a palette to your character
    _G.charSelect.character_add_palette_preset(E_MODEL_MARTLET, PALETTE_MARTLET)

    -- Adds a health meter to your character
    -- (Textures do not exist in template)
    _G.charSelect.character_add_health_meter(CT_MARTLET, HEALTH_METER_MARTLET)
	
	-- Adds custom animations
	_G.charSelect.character_add_animations(E_MODEL_MARTLET, ANIMTABLE_MARTLET)
	
	-- Adds custom moveset
	_G.charSelect.character_hook_moveset(CT_MARTLET, HOOK_MARIO_UPDATE, martlet_update)
	_G.charSelect.character_hook_moveset(CT_MARTLET, HOOK_ON_SET_MARIO_ACTION, on_set_martlet_action)
	_G.charSelect.character_hook_moveset(CT_MARTLET, HOOK_BEFORE_SET_MARIO_ACTION, before_set_martlet_action)
	_G.charSelect.character_hook_moveset(CT_MARTLET, HOOK_ON_HUD_RENDER, on_martlet_hud_render)

	--_G.charSelect.dialog_set_replace_name("Martlet")
	
    -- Adds credits to the credits menu
    _G.charSelect.credit_add(TEXT_MOD_NAME, "Team UTY", "Character")
	_G.charSelect.credit_add(TEXT_MOD_NAME, "Emmalume", "Design")
	_G.charSelect.credit_add(TEXT_MOD_NAME, "Ciozio", "Voice Acting")
	_G.charSelect.credit_add(TEXT_MOD_NAME, "Micharus", "Model, Textures, Setup")

    CSloaded = true
end

-- Character Voice hooks
local function on_character_sound(m, sound)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_MARTLET then return _G.charSelect.voice.sound(m, sound) end
end

local function on_character_snore(m)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_MARTLET then return _G.charSelect.voice.snore(m) end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)